stages:
  - test
  - release
  - deploy

test-mario:
  stage: test
  image: python:3.6
  services:
    - postgres:latest
  variables:
    POSTGRES_DB: allocateam_test
    POSTGRES_USER: postgres
    POSTGRES_PASSWORD: "postgres"
    FLASK_APP: mario.py
    SECRET_KEY: this-is-only-temporary
    APP_SETTINGS: config.TestingConfig
    DATABASE_URL: postgresql://postgres:postgres@postgres:5432/allocateam_test
  script:
    - pip install -r mario/requirements.txt
    - cd mario
    - flake8
    - coverage run -m unittest discover -s tests -p 'test_*.py'
    - coverage report
  coverage: /TOTAL\s*[1-9].+\s+([1-9].+)%/

test-peach:
  stage: test
  image: node:8.9
  script:
    - cd peach
    - npm install
    - npm run test
  coverage: /All files\s*\|\s*([\d\.]+)/

release:
  stage: release
  image: docker:latest
  services:
    - docker:dind
  before_script:
    - BRANCH_NAME=$CI_COMMIT_REF_NAME
    - BRANCH_NAME=${BRANCH_NAME//_}
    - IMAGE_TAG_MARIO=${CI_REGISTRY_IMAGE}/${BRANCH_NAME}/mario:${CI_COMMIT_SHA}
    - IMAGE_TAG_MARIO_LATEST=${CI_REGISTRY_IMAGE}/${BRANCH_NAME}/mario:latest
    - IMAGE_TAG_PEACH=${CI_REGISTRY_IMAGE}/${BRANCH_NAME}/peach:${CI_COMMIT_SHA}
    - IMAGE_TAG_PEACH_LATEST=${CI_REGISTRY_IMAGE}/${BRANCH_NAME}/peach:latest
  script:
    - docker login -u gitlab-ci-token -p ${CI_BUILD_TOKEN} ${CI_REGISTRY}
    - docker build -t ${IMAGE_TAG_MARIO}
      --build-arg SECRET_KEY=${SECRET_KEY}
      --build-arg FLASK_APP=${FLASK_APP}
      --build-arg APP_SETTINGS=${APP_SETTINGS}
      --build-arg DATABASE_URL="postgresql://postgres:TemporaryC4!@168.61.51.16/"${BRANCH_NAME}
      --build-arg DATABASE_URL_PRIVATE="postgresql://postgres:TemporaryC4!@10.240.0.7/"${BRANCH_NAME}
      ./mario
    - docker build -t ${IMAGE_TAG_PEACH} ./peach
    - docker tag ${IMAGE_TAG_MARIO} ${IMAGE_TAG_MARIO_LATEST}
    - docker tag ${IMAGE_TAG_PEACH} ${IMAGE_TAG_PEACH_LATEST}
    - docker push ${IMAGE_TAG_MARIO}
    - docker push ${IMAGE_TAG_MARIO_LATEST}
    - docker push ${IMAGE_TAG_PEACH}
    - docker push ${IMAGE_TAG_PEACH_LATEST}
  only:
    refs:
      - master
      - sit_uat
      - coba_coba

deploy:
  stage: deploy
  image: roffe/kubectl:v1.9.3
  variables:
    KUBECONFIG: /etc/deploy/config
  before_script:
    - BRANCH_NAME=$CI_COMMIT_REF_NAME
    - BRANCH_NAME=${BRANCH_NAME//_}
    - IMAGE_TAG_MARIO=${CI_REGISTRY_IMAGE}/${BRANCH_NAME}/mario:${CI_COMMIT_SHA}
    - IMAGE_TAG_PEACH=${CI_REGISTRY_IMAGE}/${BRANCH_NAME}/peach:${CI_COMMIT_SHA}
  script:
    - mkdir /etc/deploy/
    - echo "${KUBECONFIG64}" | base64 -d > ${KUBECONFIG}
    - kubectl set image deployments/mario-${BRANCH_NAME} mario-${BRANCH_NAME}=${IMAGE_TAG_MARIO}
    - kubectl set image deployments/peach-${BRANCH_NAME} peach-${BRANCH_NAME}=${IMAGE_TAG_PEACH}
    - kubectl set image replicationcontrollers/luigi-${BRANCH_NAME} luigi-${BRANCH_NAME}=${IMAGE_TAG_MARIO}
  only:
    refs:
      - master
      - sit_uat
      - coba_coba